<template>
  <div><!-- this should probably be a function component --></div>
</template>

<script>
import { mapActions, mapState } from 'vuex'
import directions from './directions'

const directionFromKeyEvent = event => {
  const match = /^Arrow(.*)$/.exec(event.key)
  return match && directions[match[1].toUpperCase()]
}

export default {
  computed: {
    ...mapState(['activeCharacter'])
  },
  mounted() {
    document.addEventListener('keydown', this.onKeyDown)
    document.addEventListener('keyup', this.onKeyUp)
  },
  beforeDestroy() {
    document.removeEventListener('keydown', this.onKeyDown)
    document.removeEventListener('keyup', this.onKeyUp)
  },
  methods: {
    ...mapActions([
      'jump',
      'startWalking',
      'stopWalking',
      'setWalkingDirection'
    ]),

    onKeyDown(event) {
      const keyDirection = directionFromKeyEvent(event)

      if (!keyDirection) {
        return
      }

      if (['ArrowLeft', 'ArrowRight'].includes(event.key)) {
        this.startWalking({
          id: this.activeCharacter,
          x: keyDirection.x / 80,
          y: 0
        })
        this.setWalkingDirection(keyDirection)
      } else if (event.key === 'ArrowUp') {
        this.jump({
          id: this.activeCharacter,
          x: 0,
          y: keyDirection.y / 10
        })
      }
    },
    onKeyUp(event) {
      if (['ArrowLeft', 'ArrowRight'].includes(event.key)) {
        this.stopWalking()
      }
    }
  }
}
</script>
